package sos.stresstest;

/**
 * @author Andreas Pschel <andreas.pueschel@sos-berlin.com>
 * @since 2004-11-21
 * @version 1.1
 * 
 * 
 * StresstestSession kann als abstrakte Klasse nicht instanziiert werden, jedoch kann der StresstestThread
 * von ihr erbende nicht abstrakte Klassen instanziieren. Dadurch ist es mglich nachtrglich 
 * Java-Klassen zu schreiben auf die der StresstestThread ber den Klassennamen zugreifen kann
 *  ohne das im StresstestThread, StresstestSession und SOSStresstestSession verndert werden muss.
 * 
 */
public class StresstestResponse {

	
	/** Attribut: responseCode: Rckgabewert (0=ok, 1=Fehler etc.) */
	int responseCode = 0;
	
	/** Attribut: responseMessage: Nachricht */
	String responseMessage = new String("");
	
	
	public StresstestResponse() {
	}
	
	public StresstestResponse( int responseCode) {

		this.setResponseMessage(responseMessage);
	}
	
	public StresstestResponse( int responseCode, String responseMessage) {

		this.setResponseCode(responseCode);
		this.setResponseMessage(responseMessage);
	}
	

	/**
	 * @return Returns the responseCode.
	 */
	public int getResponseCode() {
		return responseCode;
	}
	
	/**
	 * @return Returns the responseCode.
	 */
	public int get_response_code() {
		return responseCode;
	}
	
	/**
	 * @param responseCode The responseCode to set.
	 */
	protected void setResponseCode(int responseCode) {
		this.responseCode = responseCode;
	}
	
	/**
	 * @return Returns the responseMessage.
	 */
	public String getResponseMessage() {
		return responseMessage;
	}
	
	/**
	 * @return Returns the responseMessage.
	 */
	public String get_response_message() {
		return responseMessage;
	}
	
	/**
	 * @param responseMessage The responseMessage to set.
	 */
	protected void setResponseMessage(String responseMessage) {
		this.responseMessage = responseMessage;
	}
}
