/*
 * Created on 09.12.2004
 *  
 */
package sos.stresstest.dialogtest;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.UnknownHostException;

import java.net.URL;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import sos.util.SOSClassUtil;
import sos.util.SOSLogger;
//import sos.util.SOSStandardLogger;


/**
 * @author ur
 * 
 * Ein Dialogschritt innerhalb eines zu testenden Checkpoints
 */

public class DialogStep extends DialogTesterBasic {
		
    private URL url = null;
    private int nr = 0;
    //private HashMap dialogstep;
    private HashMap request;
    private HashMap header;
    private DialogTester caller;
    private DialogCheckpoint checkpoint;
    private String requestMethod;
    
    protected DialogStep(SOSLogger sosLogger_, String u, int n, HashMap r, HashMap h, HashMap d)
            throws Exception {
				
        url = new URL(u);
       	
        nr = n;
        r.put("skip_recording", "1"); // Damit die Ausfhrung des Mitschnitts
                                      // nicht mitgeschnitten wird.
        request = r;
        header = h;
        //dialogstep = d;
        sosLogger = sosLogger_;
    }
		
    protected void printHeader() throws Exception {
    	
    	try {
        log_info("Header");
        log_info("-------");
        Iterator keys = header.keySet().iterator();
        Iterator vals = header.values().iterator();
				while (keys.hasNext()) {
					log_info(keys.next() + "=" + vals.next());
        }
    	} catch (Exception e) {
    		String err_msg = "";
  			if (this.getDebugLevel()>2)
  				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
    		throw new Exception(err_msg + e.getMessage());
    	}
    }
		
    protected void printRequest() throws Exception {
    	
    	try {
        log_info("Request");
        log_info("-------");
        Iterator keys = request.keySet().iterator();
        Iterator vals = request.values().iterator();
        while (keys.hasNext()) {
            log_info(keys.next() + "=" + vals.next());
        }
    	} catch (Exception e) {
    		String err_msg = "";
  			if (this.getDebugLevel()>2)
  				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
    		throw new Exception(err_msg + e.getMessage());
    	}
    }

    protected int getNr() {
        return nr;
    }

    protected URL getUrl() {
        return url;
    }
		
    protected void setUrl(URL _url) {
      this.url = _url;
  	}
    
		protected void showHeaderFields(HttpURLConnection connection) throws Exception {
    	
			try {
	    	Map fields = connection.getHeaderFields();
	  		Iterator it = fields.keySet().iterator();
				
	  		this.log_info("Header-Fields: ____________________________________________________");
	  		
	  		while(it.hasNext()) {
	  			String key = (String)it.next();
	  			String value = fields.get(key).toString();
	  			
	  			this.log_info("Header-Field:  key=" + key + "  value=" + value);
	  		}
	  		this.log_info("___________________________________________________________________");
			} catch (Exception e) {
				String err_msg = "";
				if (this.getDebugLevel()>2)
					err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
	  		throw new Exception(err_msg + e.getMessage());
			}
		}
		
		/**
		 * ermittelt die SessionID innerhalb eines Headers.
		 * @param fields der Header als Map
		 * @param subKey der Schlssel (der sessionIDKey)
		 * @return die sessionID
		 */
		private String identifySessionID(Map fields, String sessionIDKey) throws Exception {
			
			String sessionID = null;
			
			try {
				
				if ( sessionIDKey==null ) {
					this.log_debug4("DialogStep.identifySessionID: sessionIDKey is null");
					return null;
				}
				
				Iterator it = fields.keySet().iterator();
				
				Pattern pattern = Pattern.compile( ".*"+sessionIDKey+"=([\\dA-Fa-f]+).*");
				Matcher matcher;
				String key;
				String value;
				
				while( it.hasNext() && (sessionID==null) ) {
					
					key = (String)it.next();
					value = fields.get(key).toString();
					matcher = pattern.matcher( value );
					
					if ( matcher.matches() ) {
						if (matcher.groupCount() == 1) {
							sessionID = matcher.group(1);
						}
					}
				}
				
			} catch (Exception e) {
				String err_msg = "";
				if (this.getDebugLevel()>2)
					err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
	  		throw new Exception(err_msg + e.getMessage());
			}
			
			return sessionID;
		}
		
		protected boolean execute() throws Exception {
    		
        String k, v = "";
        StringBuffer buffer = null;
        File f = null;
        BufferedWriter outputFile = null;
        int responseCode=0;
				
        boolean success = true;
        DialogTesterChecks check;
        HttpURLConnection uc;
				
        String oldSessionID = null;
        
        try {
						
        		log_debug5("execute URL = \""+url.toString() +"\"  PORT = \""+url.getPort()+"\"");
						
            uc = (HttpURLConnection) url.openConnection();
            
						uc.setDoOutput(true);
            HttpURLConnection.setFollowRedirects(true);
            uc.setRequestMethod(this.requestMethod);
            uc.setUseCaches(false);
            uc.setDoInput(true);
            
            // log_debug5("using_proxy = "+uc.usingProxy());
            
            // Step-Counter um eins erhhen
          	// wenn dies der erste Step des Recordings ist,
          	// dann auf Method POST mit SessionID im Cookie prfen und in diesem Fall warnen
            if ( caller.get_next_stepc()==1 ) {
            	if ( this.getRequestMethod().equals("POST") &&
									 null != (oldSessionID = this.identifySessionID((Map)header, caller.getSessionIDKey())) )
            		this.log_warn("(login?) First step request-method is POST and SessionID is already set - request-method GET expected");
            }
            
            // die aufgenommene SessionId (aus dem Recording) ermitteln
            if (caller.getSessionIDKey() != null) {
            	
            	// SessionID aus dem Cookie im Header extrahieren
            	oldSessionID = this.identifySessionID( (Map)header, caller.getSessionIDKey() );
            	
							if (oldSessionID == null) {
								this.log_debug4("SessionIDKey: \""+ caller.getSessionIDKey() +"\" not found in header");
							}
            }
						
            //  Den Header setzen.
            Iterator headerVals = header.values().iterator();
            Iterator headerKeys = header.keySet().iterator();
            log_debug4("Execute Step:" + nr + " --> Set Header");
            
            Pattern p;
            Matcher m;
            String oldV;
            
            while (headerKeys.hasNext()) {
            		
                k = headerKeys.next().toString();
                v = headerVals.next().toString();
								
                if ( (caller.getSessionIDKey()!=null) && (caller.getSessionID()!=null) && (oldSessionID!=null) ) {
                	
                	p = Pattern.compile( oldSessionID );
                	m = p.matcher( v );
                	
                	oldV = v;
                	v = m.replaceAll( caller.getSessionID() );
                	
                	if ( !v.equals(oldV) ) {
                		caller.setSessionIDReplaces(true);
                		this.log_debug4("Cookie-Replacement:");
                		this.log_debug4("old: "+oldV);
                		this.log_debug4("new: "+v);
                	}
                }
                
                uc.setRequestProperty(k, v);
                log_debug4("Execute Step:" + " " + k + "=" + v);
            }
            
            // Den Request schreiben
            log_debug5("HttpURLConnection: "+uc.toString());
            
            log_debug5("creating OutputStreamWriter");
            
						if ( uc.getErrorStream() != null) {
		          InputStreamReader isr = new InputStreamReader(uc.getErrorStream());
		      		BufferedReader br = new BufferedReader(isr);
		      		String line = null;
		      		while ( (line = br.readLine()) != null) {
		      			this.log_debug5(line);
		      		}            
						} else {
							//log_debug5("ErrorStream is null");
						}
						
						OutputStreamWriter osw;
						
						if ( uc.getOutputStream() != null) {
							//log_debug5("OutputStream is not null");
							log_debug5("getOutputStream: "+uc.getOutputStream().toString());
							osw = new OutputStreamWriter(uc.getOutputStream());
						} else {
							throw new Exception("OutputStream is null");
						}
						
            log_debug5("OutputStreamWriter created");
            Iterator requestVals = request.values().iterator();
            Iterator requestKeys = request.keySet().iterator();
            String und = "";
            
            log_debug4("Execute Step:" + nr + " --> Set Request");
            while (requestKeys.hasNext()) {
                k = requestKeys.next().toString();
                v = requestVals.next().toString();
								
                osw.write(und + k + "=" + v);
                und = "&";
                log_debug4("Execute Step:" + " " + k + "=" + v);
            }
						
            log_debug5("steps executed; flush OutputStreamWriter...");
            osw.flush();
            log_debug5("OutputStreamWriter flushed; close OutputStreamWriter...");
            osw.close();
            log_debug5("OutputStreamWriter closed");
						
            buffer = new StringBuffer();
            if (caller.isCopyHtmlToFile()) {
                f = new File(caller.getPath() + checkpoint.getTake() + "_" + checkpoint.getName() + "_" + nr + ".html");
                f.delete();
            }
						
            log_debug5("HttpURLConnection: connecting...");
            try {
							uc.connect();
            } catch (Exception e) {
            	throw new Exception("HttpURLConnection: cannot connect -> "+e.getMessage());
            }
            log_debug5("HttpURLConnection: connected");
            
            // SessionID wird beim ersten Request ermittelt
						if ( caller.getSessionIDKey() != null && caller.getSessionID() == null ) {
							caller.setSessionID(this.identifySessionID(uc.getHeaderFields(), caller.getSessionIDKey()));
							if (caller.getSessionID() != null)
								this.log_debug3("current SessionID: "+caller.getSessionID());
						}
            
						log_debug5("creating InputStream...");
            InputStream is = uc.getInputStream();
            log_debug5("InputStream created");
            
            responseCode = uc.getResponseCode();            
            log_debug5("Response --> Message: \""+uc.getResponseMessage()+"\", Code: "+responseCode);
            
            if (responseCode < 200  ||  responseCode > 300) {
							throw new Exception ("Response --> Message: \"" +  uc.getResponseMessage() + "\", Code: " + responseCode);
            }
            
            if (caller.isCopyHtmlToFile() || caller.isShowHtml() || checkpoint.getListOfChecks().size() > 0) {
                int a = 0;
                if (caller.isCopyHtmlToFile()) {
                    outputFile = new BufferedWriter(new FileWriter(f, true));
                }
                while (a != -1) {
                    a = is.read();
                    if (caller.isShowHtml()) {
                        System.out.print((char) a);
                    }
                    if (caller.isCopyHtmlToFile() || checkpoint.getListOfChecks().size() > 0) {
                        buffer.append((char) a);
                    }
                }
                if (caller.isCopyHtmlToFile()) {
                    outputFile.write(buffer.toString());
                    outputFile.flush();

                    outputFile.close();
                }
                is.close();
            }
            
						
            for (int i = 0; i < checkpoint.getListOfChecks().size(); i++) {
            		
                check = (DialogTesterChecks) checkpoint.getListOfChecks().get(i);
                
                FilterMatcher fm = new FilterMatcher(check.getSearchString(), buffer.toString(), caller.getGlobalVars(), Pattern.CASE_INSENSITIVE);
                
								// ausgewerteter String mit Wildcards an check selbst liefern
                check.setEvalVarString( fm.getSearchString() );
                
                log_debug4("extended matching with Vars: " + check.getSearchString());
                log_debug3("...matching \""+ fm.getSearchString() +"\"");
                
                
                if ( !fm.find() ) {
                    log_debug3("Step:" + nr + " --> " + fm.getSearchString()
                            + " nicht im HTML enthalten! [NOT FOUND]");
                } else {
                    log_debug3("Step:" + nr + " --> " + fm.getSearchString() + " gefunden [found]");
                    log_debug4("show set vars: "+fm.showVars());
                    check.setFound(true);
                    // Wenn mindestens ein Step den Suchstring enthlt, wird "true" geliefert
                }
            }
            
            log_debug5("HttpURLConnection: disconnecting...");
            uc.disconnect();
            log_debug5("HttpURLConnection: disconnected");
            
				} catch (UnknownHostException e) {
					try {log_warn("Unknown Host: "+e.getMessage());} catch (Exception ex) {}
					success = true;
					
        } catch (MalformedURLException e) {
					success = true;
					
        } catch (Exception e) {
        	String err_msg = "";
    			if (this.getDebugLevel()>2)
    				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
        	
					err_msg += "\nError at URL:(" + nr + ")" + url + ": Response --> Code: " + responseCode;					
					throw new Exception(err_msg);
        }
        
        return success;
    }
		
    protected void setCaller(DialogTester caller) {
        this.caller = caller;
    }

    /**
     * @param checkpoint
     *            The checkpoint to set.
     */
    protected void setCheckpoint(DialogCheckpoint checkpoint) {
        this.checkpoint = checkpoint;
    }

    /**
     * @return Returns the requestMethode.
     */
    protected String getRequestMethod() {
        return requestMethod;
    }

    /**
     * @param requestMethod
     *            The requestMethod to set.
     */
    protected void setRequestMethod(String requestMethod) {
        if (requestMethod.equals("")) {
            this.requestMethod = "POST";
        } else {
            this.requestMethod = requestMethod;
        }
    }

    /**
     * @param request
     *            The request to set.
     */
    protected void setRequest(HashMap request) {
        this.request = request;
    }
}