/*
 * Created on 13.12.2004
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package sos.stresstest.dialogtest;

import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

//import sos.util.SOSClassUtil;

/**
 * @author ur
 * 
 *Eine Requester-Tag nderung. Wird mit den Methoden changeTagValue.. des Dialogtester erzeugt.
 */
public class DialogTesterTags {

    private String tagName = "";

    private String oldValue = "";

    private String newValue = "";
		
    // der neue Wert mit ersetzten Variablen
    private String newValueParsed = null;
    
    private HashMap globals = null;
    
    private String take = "system";

    private String startDialogCheckpoint = "system";

    private String endDialogCheckpoint = "system";

    private boolean active = false;
		
    private boolean checksEnabled;
    
    
		public DialogTesterTags(String tagName, String oldValue, String newValue, String take,
            String startDialogCheckpoint, String endDialogCheckpoint) {
        super();
        this.tagName = tagName;
        this.newValue = newValue;
        this.oldValue = oldValue;
        this.take = take;
        this.startDialogCheckpoint = startDialogCheckpoint;
        this.endDialogCheckpoint = endDialogCheckpoint;
    }

    /**
     * @return Returns the newValue.
     */
    protected String getNewValue() {
        return newValue;
    }
		
    /**
     * @return Returns the newValue with replaced vars.
     */
		protected String getNewValueParsed() throws Exception {
			
			try {
				
				if (this.newValueParsed == null) {
					this.newValueParsed = this.parseValue();
				}
				
			} catch (Exception e) {
				String err_msg = e.getMessage();
				throw new Exception(err_msg);
			}
			
			return this.newValueParsed;
    }
		
		/**
		 * replaces vars in the value and returns the new value
		 * @return parsed value
		 */
		private String parseValue() throws Exception {
			
			String result = this.newValue;
			String rplmnt = null;
			String match = null;
			
			try {
				
				Pattern pattern = Pattern.compile("<\\$[\\w]+>");
				Matcher matcher = pattern.matcher(result);
				
				while ( matcher.find() ) {
					
					match = matcher.group();
					
					if ( this.globals == null )
						throw new Exception("parsing \""+this.newValue+"\": no replacement for variable \""+match+"\" existing (container is null)");
						
					if ( this.globals.isEmpty() ) {
						if ( !this.checksEnabled )
							throw new Exception("parsing \""+this.newValue+"\": no replacement for variable \""+match+"\" existing (checks are disabled)");
						else
							throw new Exception("parsing \""+this.newValue+"\": no replacement for variable \""+match+"\" existing (container is empty - verify your \"check_html\" expression)");
					}
					
					rplmnt = (String)this.globals.get( match );
					
					if ( rplmnt == null ) 
						throw new Exception("parsing \""+this.newValue+"\": no replacement for variable \""+match+"\" existing (verify your \"check_html\" expression and variable name)");
					
					result = result.replaceFirst("<\\$"+match.substring(2), rplmnt);
				}
				
			} catch (Exception e) {
				String err_msg = e.getMessage();
				throw new Exception(err_msg);
			}
			
			return result;
		}
		
    /**
     * @param newValue
     *            The newValue to set.
     */
    protected void setNewValue(String newValue) {
        this.newValue = newValue;
    }

    /**
     * @return Returns the tagName.
     */
    protected String getTagName() {
        return tagName;
    }

    /**
     * @param tagName
     *            The tagName to set.
     */
    protected void setTagName(String tagName) {
        this.tagName = tagName;
    }

    /**
     * @param tagName
     * @param newValue
     * @param startDialogStep
     * @param endDialogStep
     */

    /**
     * @return Returns the oldValue.
     */
    protected String getOldValue() {
        return oldValue;
    }

    /**
     * @return Returns the endDialogCheckpoint.
     */
    protected String getEndDialogCheckpoint() {
        return endDialogCheckpoint;
    }

    /**
     * @param endDialogCheckpoint
     *            The endDialogCheckpoint to set.
     */
    protected void setEndDialogCheckpoint(String endDialogCheckpoint) {
        this.endDialogCheckpoint = endDialogCheckpoint;
    }

    /**
     * @return Returns the startDialogCheckpoint.
     */
    protected String getStartDialogCheckpoint() {
        return startDialogCheckpoint;
    }

    /**
     * @param startDialogCheckpoint
     *            The startDialogCheckpoint to set.
     */
    protected void setStartDialogCheckpoint(String startDialogCheckpoint) {
        this.startDialogCheckpoint = startDialogCheckpoint;
    }

    /**
     * @param oldValue
     *            The oldValue to set.
     */
    protected void setOldValue(String oldValue) {
        this.oldValue = oldValue;
    }

    /**
     * @return Returns the take.
     */
    protected String getTake() {
        return take;
    }

    /**
     * @return Returns the active.
     */
    protected boolean isActive() {
        return active;
    }

    /**
     * @param active
     *            The active to set.
     */
    protected void setActive(boolean active) {
        this.active = active;
    }

		protected void setGlobals(HashMap globals) {
			this.globals = globals;
		}
		
    protected boolean isChecksEnabled() {
			return checksEnabled;
		}
		
		protected void setChecksEnabled(boolean checksEnabled) {
			this.checksEnabled = checksEnabled;
		}
		
		/*
		public static void main(String[] args) {
			
			HashMap _globals = new HashMap();
			_globals.put("<$id>", "555");
			
			DialogTesterTags dtt = new DialogTesterTags("", "", "<$id>", "", "", "");
			dtt.setGlobals(_globals);
			
			try {
				System.out.println("unparsed: "+dtt.getNewValue());
				System.out.println("  parsed: "+dtt.getNewValueParsed());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		*/
}