// $Id: xml.h 4580 2006-10-24 15:45:14Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#include "zschimmer.h"
#include "async_io.h"
#include "log.h"

namespace zschimmer {
namespace io {

using namespace ::std;

//--------------------------------------------------------Buffered_async_output_stream::write_bytes

void Buffered_async_output_stream::write_bytes( const Byte_sequence& s )
{
    try_flush();

    if( _string_list.is_empty() )
    {
        size_t written = _async_output_stream->try_write_bytes( s );

        if( written < s.length() )
        {
            _string_list.append( string( (const char*)s.ptr() + written, s.length() - written ) );
        }
    }
}

//----------------------------------------------------------Buffered_async_output_stream::try_flush

bool Buffered_async_output_stream::try_flush()
{
    while( !_string_list.is_empty() )
    {
        Byte_sequence byte_sequence = _string_list.next_byte_sequence();
        size_t written = _async_output_stream->try_write_bytes( byte_sequence );
        size_t length  = byte_sequence.length();
        _string_list.eat( written );

        if( written < length )  break;
    }

    return _string_list.is_empty();
}

//-------------------------------------------------------------------------------------------------

} //namespace io
} //namespace zschimmer
