// $Id: zschimmer.cxx 4099 2006-02-20 11:10:53Z jz $

#include "zschimmer.h"
#include "embedded_files.h"

using namespace std;


namespace zschimmer {

//-------------------------------------------------------------------------------------------static

static Message_code_text error_codes[] =
{
    { "Z-NO-EMBEDDED-FILE", "Datei $1 ist nicht eingebettet" },
    {}
};

//-------------------------------------------------------------------------------------------Z_INIT

Z_INIT( embedded_files )
{
    add_message_code_texts( error_codes ); 
}

//--------------------------------------------------------------------------------get_embedded_file
    
const Embedded_file* Embedded_files::get_embedded_file( const string& filename ) const
{
    const Embedded_file* result = get_embedded_file_or_null( filename );
    if( !result )  throw_xc( "Z-NO-EMBEDDED-FILE", filename );
    return result;
}

//--------------------------------------------------------------------------------get_embedded_file
    
const Embedded_file* Embedded_files::get_embedded_file_or_null( const string& filename ) const
{
    
    for( const Embedded_file* f = _embedded_files; f->_filename; f++ )
    {
         if( f->_filename == filename )  return f;
    }

    return NULL;
}

//------------------------------------------------------------------------string_from_embedded_file

string Embedded_files::string_from_embedded_file( const string& filename ) const
{
    const Embedded_file* embedded_file = get_embedded_file( filename );
    return string( embedded_file->_content, embedded_file->_length );
}

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer
